! Program created by Gustavo Catao Alves at
! the Stanford Exploration Project
! Jan, 5th, 2015

! finite difference module
module clib_image_ispc

  use, intrinsic :: iso_c_binding

  implicit none

  interface
    subroutine image_rho_lame_c(adj,add,nx,nz,dt,bx,ex,s1,s2,dm1_x,dm1_z,m1_x,m1_z,vx,vz) bind(c,name='image_rho_lame_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_float),value		  :: dt
      real(c_float),dimension(*)  :: s1,s2,vx,vz
      real(c_float),dimension(*)  :: dm1_x,dm1_z,m1_x,m1_z
    endsubroutine
    
     subroutine image_lambda_lame_c(adj,add,nx,nz,dt,bx,ex,s3,s4,dm2,sigmaxx,sigmazz) bind(c,name='image_lambda_lame_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_float),value		  :: dt
      real(c_float),dimension(*)  :: s3,s4,sigmaxx,sigmazz
      real(c_float),dimension(*)  :: dm2
    endsubroutine

    subroutine image_mu_lame_c(adj,add,nx,nz,dt,bx,ex,s3,s4,s5,dm3,sigmaxx,sigmazz,sigmaxz) bind(c,name='image_mu_lame_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_float),value		  :: dt
      real(c_float),dimension(*)  :: s3,s4,s5,sigmaxx,sigmazz,sigmaxz
      real(c_float),dimension(*)  :: dm3
    endsubroutine
    
    subroutine image_rho_vel_c(adj,add,nx,nz,dt,bx,ex,s1,s2,s3,s4,s5,dm1,dm1_x,dm1_z,m1_x,m1_z,m2,m3,vx,vz,sigmaxx,sigmazz,sigmaxz) bind(c,name='image_rho_vel_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_float),value		  :: dt
      real(c_float),dimension(*)  :: s1,s2,s3,s4,s5,vx,vz,sigmaxx,sigmazz,sigmaxz
      real(c_float),dimension(*)  :: dm1,dm1_x,dm1_z,m2,m3,m1_x,m1_z
    endsubroutine
    
    subroutine image_vp_vel_c(adj,add,nx,nz,dt,bx,ex,s3,s4,dm2,m1,m2,sigmaxx,sigmazz) bind(c,name='image_vp_vel_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_float),value		  :: dt
      real(c_float),dimension(*)  :: s3,s4,sigmaxx,sigmazz
      real(c_float),dimension(*)  :: dm2,m1,m2
    endsubroutine

    subroutine image_vs_vel_c(adj,add,nx,nz,dt,bx,ex,s3,s4,s5,dm3,m1,m3,sigmaxx,sigmazz,sigmaxz) bind(c,name='image_vs_vel_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_float),value		  :: dt
      real(c_float),dimension(*)  :: s3,s4,s5,sigmaxx,sigmazz,sigmaxz
      real(c_float),dimension(*)  :: dm3,m1,m3
    endsubroutine
    
    subroutine image_rho_lame_double_c(adj,add,nx,nz,dt,bx,ex,s1,s2,dm1_x,dm1_z,m1_x,m1_z,vx,vz) bind(c,name='image_rho_lame_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_double),value		  :: dt
      real(c_double),dimension(*) :: s1,s2,vx,vz
      real(c_double),dimension(*) :: dm1_x,dm1_z,m1_x,m1_z
    endsubroutine
    
     subroutine image_lambda_lame_double_c(adj,add,nx,nz,dt,bx,ex,s3,s4,dm2,sigmaxx,sigmazz) bind(c,name='image_lambda_lame_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_double),value		  :: dt
      real(c_double),dimension(*) :: s3,s4,sigmaxx,sigmazz
      real(c_double),dimension(*) :: dm2
    endsubroutine

    subroutine image_mu_lame_double_c(adj,add,nx,nz,dt,bx,ex,s3,s4,s5,dm3,sigmaxx,sigmazz,sigmaxz) bind(c,name='image_mu_lame_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_double),value		  :: dt
      real(c_double),dimension(*) :: s3,s4,s5,sigmaxx,sigmazz,sigmaxz
      real(c_double),dimension(*) :: dm3
    endsubroutine

    subroutine image_rho_vel_double_c(adj,add,nx,nz,dt,bx,ex,s1,s2,s3,s4,s5,dm1,dm1_x,dm1_z,m1_x,m1_z,m2,m3,vx,vz,sigmaxx,sigmazz,sigmaxz) bind(c,name='image_rho_vel_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_double),value		  :: dt
      real(c_double),dimension(*) :: s1,s2,s3,s4,s5,vx,vz,sigmaxx,sigmazz,sigmaxz
      real(c_double),dimension(*) :: dm1,dm1_x,dm1_z,m2,m3,m1_x,m1_z
    endsubroutine
    
    subroutine image_vp_vel_double_c(adj,add,nx,nz,dt,bx,ex,s3,s4,dm2,m1,m2,sigmaxx,sigmazz) bind(c,name='image_vp_vel_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_double),value		  :: dt
      real(c_double),dimension(*) :: s3,s4,sigmaxx,sigmazz
      real(c_double),dimension(*) :: dm2,m1,m2
    endsubroutine

    subroutine image_vs_vel_double_c(adj,add,nx,nz,dt,bx,ex,s3,s4,s5,dm3,m1,m3,sigmaxx,sigmazz,sigmaxz) bind(c,name='image_vs_vel_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
	  real(c_double),value		  :: dt
      real(c_double),dimension(*) :: s3,s4,s5,sigmaxx,sigmazz,sigmaxz
      real(c_double),dimension(*) :: dm3,m1,m3
    endsubroutine

    subroutine image_lame_c(adj,add,nx,nz,dt,bx,ex,s1,s2,s3,s4,s5,dm1_x,dm1_z,dm2,dm3,m1_x,m1_z,vx,vz,sigmaxx,sigmazz,sigmaxz) bind(c,name='image_lame_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),value		  :: dt
      real(c_float),dimension(*)  :: s1,s2,s3,s4,s5,vx,vz,sigmaxx,sigmazz,sigmaxz
      real(c_float),dimension(*)  :: dm1_x,dm1_z,dm2,dm3,m1_x,m1_z
    endsubroutine
    
    subroutine image_lame_double_c(adj,add,nx,nz,dt,bx,ex,s1,s2,s3,s4,s5,dm1_x,dm1_z,dm2,dm3,m1_x,m1_z,vx,vz,sigmaxx,sigmazz,sigmaxz) bind(c,name='image_lame_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_double),value		  :: dt
      real(c_double),dimension(*) :: s1,s2,s3,s4,s5,vx,vz,sigmaxx,sigmazz,sigmaxz
      real(c_double),dimension(*) :: dm1_x,dm1_z,dm2,dm3,m1_x,m1_z
    endsubroutine

	subroutine lintx_c(adj,add,nx,nz,m1,m1_x) bind(c,name='lintx_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx
      real(c_float),dimension(*)  :: m1,m1_x
    endsubroutine	

	subroutine lintz_c(adj,add,nx,nz,m1,m1_z) bind(c,name='lintz_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx
      real(c_float),dimension(*)  :: m1,m1_z
    endsubroutine

	subroutine lintxz_c(adj,add,nx,nz,m3,m3_xz) bind(c,name='lintxz_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx
      real(c_float),dimension(*)  :: m3,m3_xz
    endsubroutine
    
  endinterface
end module
