! Program created by Gustavo Catao Alves at
! the Stanford Exploration Project
! Jan, 5th, 2015

! finite difference module
module clib_lint_ispc

  use, intrinsic :: iso_c_binding

  implicit none

  interface
    subroutine lint_serial_c(adj,add,nrec,dt,dtseis,model,dataF,aux,it) bind(c,name='lint_serial_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nrec,it
      real(c_float),value         :: dt,dtseis,aux
      real(c_float),dimension(*)  :: model
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine lint_serial2_c(adj,add,nrec,dt,dz,dtseis,model,dataF,aux,it,zrec) bind(c,name='lint_serial2_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nrec,it
      real(c_float),value         :: dt,dtseis,dz,aux,zrec
      real(c_float),dimension(*)  :: model
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine lint_par_c(adj,add,nz,nx,ix,dt,dtseis,model,dataF,aux,it) bind(c,name='lint_par_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,it,ix
      real(c_float),value         :: dt,dtseis,aux
      real(c_float),dimension(*)  :: model
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine lint_par2_c(adj,add,nz,dt,dtseis,model1,model2,dataF,aux,it,ix) bind(c,name='lint_par2_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,it,ix
      real(c_float),value         :: dt,dtseis,aux
      real(c_float),dimension(*)  :: model1,model2
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine lint_serial_double_c(adj,add,nrec,dt,dtseis,model,dataF,aux,it) bind(c,name='lint_serial_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nrec,it
      real(c_float),value         :: dt,dtseis
      real(c_double),value        :: aux
      real(c_double),dimension(*) :: model
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine lint_serial2_double_c(adj,add,nrec,dt,dz,dtseis,model,dataF,aux,it,zrec) bind(c,name='lint_serial2_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nrec,it
      real(c_float),value         :: dt,dtseis,dz,zrec
      real(c_double),value        :: aux
      real(c_double),dimension(*) :: model
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine lint_par_double_c(adj,add,nz,nx,ix,dt,dtseis,model,dataF,aux,it) bind(c,name='lint_par_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,it,ix
      real(c_float),value         :: dt,dtseis
      real(c_double),value        :: aux
      real(c_double),dimension(*) :: model
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine lint_par2_double_c(adj,add,nz,dt,dtseis,model1,model2,dataF,aux,it,ix) bind(c,name='lint_par2_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,it,ix
      real(c_float),value         :: dt,dtseis
      real(c_double),value        :: aux
      real(c_double),dimension(*) :: model1,model2
      real(c_double),dimension(*) :: dataF
    endsubroutine

  endinterface
end module
