/*This is a C library for the 2D derivatives used in the elastic RTM code
 * 
 * Gustavo C. Alves - August, 31st, 2015 - Stanford, CA */
export void Axsides_c_(uniform int add, uniform int nx, uniform int nz, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (add==0) {
    for (uniform int ix=0;ix<nx;ix++) {
      uniform int i=ix*nz;
      for (uniform int iz=0;iz<nz;iz++){
        model[iz+i]=0.f;
      }
    }
  }
  foreach(iz=5...(nz-5)) {
    model[iz     ] +=-aux[iz+5*nz]*c1*data[iz+5*nz];
    model[iz+  nz] +=-aux[iz+6*nz]*c1*data[iz+6*nz]
			         -aux[iz+5*nz]*c2*data[iz+5*nz];
    model[iz+2*nz] +=-aux[iz+7*nz]*c1*data[iz+7*nz]
			         -aux[iz+6*nz]*c2*data[iz+6*nz]
			         -aux[iz+5*nz]*c3*data[iz+5*nz];
    model[iz+3*nz] +=-aux[iz+8*nz]*c1*data[iz+8*nz]
			         -aux[iz+7*nz]*c2*data[iz+7*nz]
			         -aux[iz+6*nz]*c3*data[iz+6*nz]
			         -aux[iz+5*nz]*c4*data[iz+5*nz];
    model[iz+4*nz] +=-aux[iz+9*nz]*c1*data[iz+9*nz]
			         -aux[iz+8*nz]*c2*data[iz+8*nz]
			         -aux[iz+7*nz]*c3*data[iz+7*nz]
			         -aux[iz+6*nz]*c4*data[iz+6*nz]
			         -aux[iz+5*nz]*c5*data[iz+5*nz];
    model[iz+5*nz] +=-aux[iz+10*nz]*c1*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c2*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c3*data[iz+ 8*nz]
			         -aux[iz+ 7*nz]*c4*data[iz+ 7*nz]
			         -aux[iz+ 6*nz]*c5*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c5*data[iz+ 5*nz];
    model[iz+6*nz] +=-aux[iz+11*nz]*c1*data[iz+11*nz]
			         -aux[iz+10*nz]*c2*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c3*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c4*data[iz+ 8*nz]
			         -aux[iz+ 7*nz]*c5*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c5*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c4*data[iz+ 5*nz];
    model[iz+7*nz] +=-aux[iz+12*nz]*c1*data[iz+12*nz]
			         -aux[iz+11*nz]*c2*data[iz+11*nz]
			         -aux[iz+10*nz]*c3*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c4*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c5*data[iz+ 8*nz]
			         +aux[iz+ 7*nz]*c5*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c4*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c3*data[iz+ 5*nz];
    model[iz+8*nz] +=-aux[iz+13*nz]*c1*data[iz+13*nz]
			         -aux[iz+12*nz]*c2*data[iz+12*nz]
			         -aux[iz+11*nz]*c3*data[iz+11*nz]
			         -aux[iz+10*nz]*c4*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c5*data[iz+ 9*nz]
			         +aux[iz+ 8*nz]*c5*data[iz+ 8*nz]
			         +aux[iz+ 7*nz]*c4*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c3*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c2*data[iz+ 5*nz];
    model[iz+(nx-2)*nz] += aux[iz+(nx-6)*nz]*c1*data[iz+(nx-6)*nz];
    model[iz+(nx-3)*nz] += aux[iz+(nx-7)*nz]*c1*data[iz+(nx-7)*nz]
						  +aux[iz+(nx-6)*nz]*c2*data[iz+(nx-6)*nz];
    model[iz+(nx-4)*nz] += aux[iz+(nx-8)*nz]*c1*data[iz+(nx-8)*nz]
						  +aux[iz+(nx-7)*nz]*c2*data[iz+(nx-7)*nz]
						  +aux[iz+(nx-6)*nz]*c3*data[iz+(nx-6)*nz];
    model[iz+(nx-5)*nz] += aux[iz+(nx-9)*nz]*c1*data[iz+(nx-9)*nz]
						  +aux[iz+(nx-8)*nz]*c2*data[iz+(nx-8)*nz]
						  +aux[iz+(nx-7)*nz]*c3*data[iz+(nx-7)*nz]
						  +aux[iz+(nx-6)*nz]*c4*data[iz+(nx-6)*nz];
    model[iz+(nx-6)*nz] += aux[iz+(nx-10)*nz]*c1*data[iz+(nx-10)*nz]
						  +aux[iz+(nx- 9)*nz]*c2*data[iz+(nx- 9)*nz]
						  +aux[iz+(nx- 8)*nz]*c3*data[iz+(nx- 8)*nz]
						  +aux[iz+(nx- 7)*nz]*c4*data[iz+(nx- 7)*nz]
						  +aux[iz+(nx- 6)*nz]*c5*data[iz+(nx- 6)*nz];
    model[iz+(nx-7)*nz] += aux[iz+(nx-11)*nz]*c1*data[iz+(nx-11)*nz]
						  +aux[iz+(nx-10)*nz]*c2*data[iz+(nx-10)*nz]
						  +aux[iz+(nx- 9)*nz]*c3*data[iz+(nx- 9)*nz]
						  +aux[iz+(nx- 8)*nz]*c4*data[iz+(nx- 8)*nz]
						  +aux[iz+(nx- 7)*nz]*c5*data[iz+(nx- 7)*nz]
						  -aux[iz+(nx- 6)*nz]*c5*data[iz+(nx- 6)*nz];
    model[iz+(nx-8)*nz] += aux[iz+(nx-12)*nz]*c1*data[iz+(nx-12)*nz]
						  +aux[iz+(nx-11)*nz]*c2*data[iz+(nx-11)*nz]
						  +aux[iz+(nx-10)*nz]*c3*data[iz+(nx-10)*nz]
						  +aux[iz+(nx- 9)*nz]*c4*data[iz+(nx- 9)*nz]
						  +aux[iz+(nx- 8)*nz]*c5*data[iz+(nx- 8)*nz]
						  -aux[iz+(nx- 7)*nz]*c5*data[iz+(nx- 7)*nz]
						  -aux[iz+(nx- 6)*nz]*c4*data[iz+(nx- 6)*nz];
    model[iz+(nx-9)*nz] += aux[iz+(nx-13)*nz]*c1*data[iz+(nx-13)*nz]
						  +aux[iz+(nx-12)*nz]*c2*data[iz+(nx-12)*nz]
						  +aux[iz+(nx-11)*nz]*c3*data[iz+(nx-11)*nz]
						  +aux[iz+(nx-10)*nz]*c4*data[iz+(nx-10)*nz]
						  +aux[iz+(nx- 9)*nz]*c5*data[iz+(nx- 9)*nz]
						  -aux[iz+(nx- 8)*nz]*c5*data[iz+(nx- 8)*nz]
						  -aux[iz+(nx- 7)*nz]*c4*data[iz+(nx- 7)*nz]
						  -aux[iz+(nx- 6)*nz]*c3*data[iz+(nx- 6)*nz];
    model[iz+(nx-10)*nz] += aux[iz+(nx-14)*nz]*c1*data[iz+(nx-14)*nz]
						   +aux[iz+(nx-13)*nz]*c2*data[iz+(nx-13)*nz]
						   +aux[iz+(nx-12)*nz]*c3*data[iz+(nx-12)*nz]
						   +aux[iz+(nx-11)*nz]*c4*data[iz+(nx-11)*nz]
						   +aux[iz+(nx-10)*nz]*c5*data[iz+(nx-10)*nz]
						   -aux[iz+(nx- 9)*nz]*c5*data[iz+(nx- 9)*nz]
						   -aux[iz+(nx- 8)*nz]*c4*data[iz+(nx- 8)*nz]
						   -aux[iz+(nx- 7)*nz]*c3*data[iz+(nx- 7)*nz]
						   -aux[iz+(nx- 6)*nz]*c2*data[iz+(nx- 6)*nz];
  }
}

export void Ax_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
	  foreach(iz=5...(nz-5)) {
    	model[iz+i] +=	 aux[iz+i-4*nz]*c1*data[iz+i-4*nz]
						+aux[iz+i-3*nz]*c2*data[iz+i-3*nz]
				  		+aux[iz+i-2*nz]*c3*data[iz+i-2*nz]
				  		+aux[iz+i-  nz]*c4*data[iz+i-  nz]
				  		+aux[iz+i     ]*c5*data[iz+i     ]
				  		-aux[iz+i+  nz]*c5*data[iz+i+  nz]
						-aux[iz+i+2*nz]*c4*data[iz+i+2*nz]
						-aux[iz+i+3*nz]*c3*data[iz+i+3*nz]
						-aux[iz+i+4*nz]*c2*data[iz+i+4*nz]
						-aux[iz+i+5*nz]*c1*data[iz+i+5*nz];
      }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
	  foreach(iz=5...(nz-5)) {
		data[iz+i] += 	aux[iz+i]*(c1*(-model[iz+i-5*nz])+
							   	   c2*(-model[iz+i-4*nz])+
								   c3*(-model[iz+i-3*nz])+
								   c4*(-model[iz+i-2*nz])+
								   c5*(-model[iz+i-  nz])+
								   c5*( model[iz+i     ])+
								   c4*( model[iz+i+  nz])+
								   c3*( model[iz+i+2*nz])+
								   c2*( model[iz+i+3*nz])+
								   c1*( model[iz+i+4*nz]));
	  }
    }
  }
}

export void Bxsides_c_(uniform int add, uniform int nx, uniform int nz, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (add==0) {
    for (uniform int ix=0;ix<nx;ix++){
      uniform int i=ix*nz;
      for (uniform int iz=0;iz<nz;iz++){
        model[i+iz]=0.f;
      }
    }
  }
  for (uniform int ix=5;ix<(nx-5);ix++) {
    uniform int i=ix*nz;
    model[i+1] +=-aux[i+5]*c1*data[i+5];
    model[i+2] +=-aux[i+6]*c1*data[i+6]
			     -aux[i+5]*c2*data[i+5];
    model[i+3] +=-aux[i+7]*c1*data[i+7]
			     -aux[i+6]*c2*data[i+6]
			     -aux[i+5]*c3*data[i+5];
    model[i+4] +=-aux[i+8]*c1*data[i+8]
			     -aux[i+7]*c2*data[i+7]
			     -aux[i+6]*c3*data[i+6]
			     -aux[i+5]*c4*data[i+5];
    model[i+5] +=-aux[i+9]*c1*data[i+9]
			     -aux[i+8]*c2*data[i+8]
			     -aux[i+7]*c3*data[i+7]
			     -aux[i+6]*c4*data[i+6]
			     -aux[i+5]*c5*data[i+5];
    model[i+6] +=-aux[i+10]*c1*data[i+10]
			     -aux[i+ 9]*c2*data[i+ 9]
			     -aux[i+ 8]*c3*data[i+ 8]
			     -aux[i+ 7]*c4*data[i+ 7]
			     -aux[i+ 6]*c5*data[i+ 6]
			     +aux[i+ 5]*c5*data[i+ 5];
    model[i+7] +=-aux[i+11]*c1*data[i+11]
			     -aux[i+10]*c2*data[i+10]
			     -aux[i+ 9]*c3*data[i+ 9]
			     -aux[i+ 8]*c4*data[i+ 8]
			     -aux[i+ 7]*c5*data[i+ 7]
			     +aux[i+ 6]*c5*data[i+ 6]
			     +aux[i+ 5]*c4*data[i+ 5];
    model[i+8] +=-aux[i+12]*c1*data[i+12]
			     -aux[i+11]*c2*data[i+11]
			     -aux[i+10]*c3*data[i+10]
			     -aux[i+ 9]*c4*data[i+ 9]
			     -aux[i+ 8]*c5*data[i+ 8]
			     +aux[i+ 7]*c5*data[i+ 7]
			     +aux[i+ 6]*c4*data[i+ 6]
			     +aux[i+ 5]*c3*data[i+ 5];
    model[i+9] +=-aux[i+13]*c1*data[i+13]
			     -aux[i+12]*c2*data[i+12]
			     -aux[i+11]*c3*data[i+11]
			     -aux[i+10]*c4*data[i+10]
			     -aux[i+ 9]*c5*data[i+ 9]
			     +aux[i+ 8]*c5*data[i+ 8]
			     +aux[i+ 7]*c4*data[i+ 7]
			     +aux[i+ 6]*c3*data[i+ 6]
			     +aux[i+ 5]*c2*data[i+ 5];
    model[i+nz-1] += aux[i+nz-6]*c1*data[i+nz-6];
    model[i+nz-2] += aux[i+nz-7]*c1*data[i+nz-7]
			        +aux[i+nz-6]*c2*data[i+nz-6];
    model[i+nz-3] += aux[i+nz-8]*c1*data[i+nz-8]
				 	+aux[i+nz-7]*c2*data[i+nz-7]
				 	+aux[i+nz-6]*c3*data[i+nz-6];
    model[i+nz-4] += aux[i+nz-9]*c1*data[i+nz-9]
				 	+aux[i+nz-8]*c2*data[i+nz-8]
			        +aux[i+nz-7]*c3*data[i+nz-7]
				 	+aux[i+nz-6]*c4*data[i+nz-6];
    model[i+nz-5] += aux[i+nz-10]*c1*data[i+nz-10]
				 	+aux[i+nz- 9]*c2*data[i+nz- 9]
			        +aux[i+nz- 8]*c3*data[i+nz- 8]
			        +aux[i+nz- 7]*c4*data[i+nz- 7]
			        +aux[i+nz- 6]*c5*data[i+nz- 6];
    model[i+nz-6] += aux[i+nz-11]*c1*data[i+nz-11]
			        +aux[i+nz-10]*c2*data[i+nz-10]
			        +aux[i+nz- 9]*c3*data[i+nz- 9]
			        +aux[i+nz- 8]*c4*data[i+nz- 8]
			        +aux[i+nz- 7]*c5*data[i+nz- 7]
			        -aux[i+nz- 6]*c5*data[i+nz- 6];
    model[i+nz-7] += aux[i+nz-12]*c1*data[i+nz-12]
			        +aux[i+nz-11]*c2*data[i+nz-11]
			        +aux[i+nz-10]*c3*data[i+nz-10]
			        +aux[i+nz- 9]*c4*data[i+nz- 9]
			        +aux[i+nz- 8]*c5*data[i+nz- 8]
			        -aux[i+nz- 7]*c5*data[i+nz- 7]
			        -aux[i+nz- 6]*c4*data[i+nz- 6];
    model[i+nz-8] += aux[i+nz-13]*c1*data[i+nz-13]
			        +aux[i+nz-12]*c2*data[i+nz-12]
			        +aux[i+nz-11]*c3*data[i+nz-11]
			        +aux[i+nz-10]*c4*data[i+nz-10]
			        +aux[i+nz- 9]*c5*data[i+nz- 9]
			        -aux[i+nz- 8]*c5*data[i+nz- 8]
			        -aux[i+nz- 7]*c4*data[i+nz- 7]
			        -aux[i+nz- 6]*c3*data[i+nz- 6];
    model[i+nz-9] += aux[i+nz-14]*c1*data[i+nz-14]
				    +aux[i+nz-13]*c2*data[i+nz-13]
			     	+aux[i+nz-12]*c3*data[i+nz-12]
			        +aux[i+nz-11]*c4*data[i+nz-11]
			        +aux[i+nz-10]*c5*data[i+nz-10]
			        -aux[i+nz- 9]*c5*data[i+nz- 9]
			        -aux[i+nz- 8]*c4*data[i+nz- 8]
			        -aux[i+nz- 7]*c3*data[i+nz- 7]
			        -aux[i+nz- 6]*c2*data[i+nz- 6];
  }
}

export void Bx_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
      foreach(iz=10...(nz-9)) {
        model[iz+i] += 	 aux[iz+i-5]*c1*data[iz+i-5]
					  	+aux[iz+i-4]*c2*data[iz+i-4]
				  		+aux[iz+i-3]*c3*data[iz+i-3]
						+aux[iz+i-2]*c4*data[iz+i-2]
						+aux[iz+i-1]*c5*data[iz+i-1]
						-aux[iz+i  ]*c5*data[iz+i  ]
						-aux[iz+i+1]*c4*data[iz+i+1]
						-aux[iz+i+2]*c3*data[iz+i+2]
						-aux[iz+i+3]*c2*data[iz+i+3]
						-aux[iz+i+4]*c1*data[iz+i+4];
      }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
      foreach(iz=5...(nz-5)) {
        data[iz+i] += aux[iz+i]*(  c1*(-model[iz+i-4])+
								   c2*(-model[iz+i-3])+
								   c3*(-model[iz+i-2])+
								   c4*(-model[iz+i-1])+
								   c5*(-model[iz+i  ])+
								   c5*( model[iz+i+1])+
								   c4*( model[iz+i+2])+
								   c3*( model[iz+i+3])+
								   c2*( model[iz+i+4])+
								   c1*( model[iz+i+5]));
      }
    }
  }
}

export void Azsides_c_(uniform int add, uniform int nx, uniform int nz, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (add==0) {
    for (uniform int ix=0;ix<nx;ix++) {
      uniform int i=ix*nz;
      for (uniform int iz=0;iz<nz;iz++) {
        model[iz+i]=0.f;
      }
    }
  }
  foreach(iz=5...(nz-5)) {
    model[iz+  nz] +=-aux[iz+5*nz]*c1*data[iz+5*nz];
    model[iz+2*nz] +=-aux[iz+6*nz]*c1*data[iz+6*nz]
			         -aux[iz+5*nz]*c2*data[iz+5*nz];
    model[iz+3*nz] +=-aux[iz+7*nz]*c1*data[iz+7*nz]
			         -aux[iz+6*nz]*c2*data[iz+6*nz]
			         -aux[iz+5*nz]*c3*data[iz+5*nz];
    model[iz+4*nz] +=-aux[iz+8*nz]*c1*data[iz+8*nz]
			         -aux[iz+7*nz]*c2*data[iz+7*nz]
			         -aux[iz+6*nz]*c3*data[iz+6*nz]
			         -aux[iz+5*nz]*c4*data[iz+5*nz];
    model[iz+5*nz] +=-aux[iz+9*nz]*c1*data[iz+9*nz]
			         -aux[iz+8*nz]*c2*data[iz+8*nz]
			         -aux[iz+7*nz]*c3*data[iz+7*nz]
			         -aux[iz+6*nz]*c4*data[iz+6*nz]
			         -aux[iz+5*nz]*c5*data[iz+5*nz];
    model[iz+6*nz] +=-aux[iz+10*nz]*c1*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c2*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c3*data[iz+ 8*nz]
			         -aux[iz+ 7*nz]*c4*data[iz+ 7*nz]
			         -aux[iz+ 6*nz]*c5*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c5*data[iz+ 5*nz];
    model[iz+7*nz] +=-aux[iz+11*nz]*c1*data[iz+11*nz]
			         -aux[iz+10*nz]*c2*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c3*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c4*data[iz+ 8*nz]
			         -aux[iz+ 7*nz]*c5*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c5*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c4*data[iz+ 5*nz];
    model[iz+8*nz] +=-aux[iz+12*nz]*c1*data[iz+12*nz]
			         -aux[iz+11*nz]*c2*data[iz+11*nz]
			         -aux[iz+10*nz]*c3*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c4*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c5*data[iz+ 8*nz]
			         +aux[iz+ 7*nz]*c5*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c4*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c3*data[iz+ 5*nz];
    model[iz+9*nz] +=-aux[iz+13*nz]*c1*data[iz+13*nz]
			         -aux[iz+12*nz]*c2*data[iz+12*nz]
			         -aux[iz+11*nz]*c3*data[iz+11*nz]
			         -aux[iz+10*nz]*c4*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c5*data[iz+ 9*nz]
			         +aux[iz+ 8*nz]*c5*data[iz+ 8*nz]
			         +aux[iz+ 7*nz]*c4*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c3*data[iz+ 6*nz]			         
			         +aux[iz+ 5*nz]*c2*data[iz+ 5*nz];
    model[iz+(nx-1)*nz] += aux[iz+(nx-6)*nz]*c1*data[iz+(nx-6)*nz];
    model[iz+(nx-2)*nz] += aux[iz+(nx-7)*nz]*c1*data[iz+(nx-7)*nz]
					      +aux[iz+(nx-6)*nz]*c2*data[iz+(nx-6)*nz];
    model[iz+(nx-3)*nz] += aux[iz+(nx-8)*nz]*c1*data[iz+(nx-8)*nz]
					      +aux[iz+(nx-7)*nz]*c2*data[iz+(nx-7)*nz]
					      +aux[iz+(nx-6)*nz]*c3*data[iz+(nx-6)*nz];
    model[iz+(nx-4)*nz] += aux[iz+(nx-9)*nz]*c1*data[iz+(nx-9)*nz]
					      +aux[iz+(nx-8)*nz]*c2*data[iz+(nx-8)*nz]
					      +aux[iz+(nx-7)*nz]*c3*data[iz+(nx-7)*nz]
					      +aux[iz+(nx-6)*nz]*c4*data[iz+(nx-6)*nz];
    model[iz+(nx-5)*nz] += aux[iz+(nx-10)*nz]*c1*data[iz+(nx-10)*nz]
					      +aux[iz+(nx- 9)*nz]*c2*data[iz+(nx- 9)*nz]
					      +aux[iz+(nx- 8)*nz]*c3*data[iz+(nx- 8)*nz]
					      +aux[iz+(nx- 7)*nz]*c4*data[iz+(nx- 7)*nz]
					      +aux[iz+(nx- 6)*nz]*c5*data[iz+(nx- 6)*nz];
    model[iz+(nx-6)*nz] += aux[iz+(nx-11)*nz]*c1*data[iz+(nx-11)*nz]
					      +aux[iz+(nx-10)*nz]*c2*data[iz+(nx-10)*nz]
					      +aux[iz+(nx- 9)*nz]*c3*data[iz+(nx- 9)*nz]
					      +aux[iz+(nx- 8)*nz]*c4*data[iz+(nx- 8)*nz]
					      +aux[iz+(nx- 7)*nz]*c5*data[iz+(nx- 7)*nz]
					      -aux[iz+(nx- 6)*nz]*c5*data[iz+(nx- 6)*nz];
    model[iz+(nx-7)*nz] += aux[iz+(nx-12)*nz]*c1*data[iz+(nx-12)*nz]
					      +aux[iz+(nx-11)*nz]*c2*data[iz+(nx-11)*nz]
					      +aux[iz+(nx-10)*nz]*c3*data[iz+(nx-10)*nz]
					      +aux[iz+(nx- 9)*nz]*c4*data[iz+(nx- 9)*nz]
					      +aux[iz+(nx- 8)*nz]*c5*data[iz+(nx- 8)*nz]
					      -aux[iz+(nx- 7)*nz]*c5*data[iz+(nx- 7)*nz]
					      -aux[iz+(nx- 6)*nz]*c4*data[iz+(nx- 6)*nz];
    model[iz+(nx-8)*nz] += aux[iz+(nx-13)*nz]*c1*data[iz+(nx-13)*nz]
				          +aux[iz+(nx-12)*nz]*c2*data[iz+(nx-12)*nz]
					      +aux[iz+(nx-11)*nz]*c3*data[iz+(nx-11)*nz]
					      +aux[iz+(nx-10)*nz]*c4*data[iz+(nx-10)*nz]
					      +aux[iz+(nx- 9)*nz]*c5*data[iz+(nx- 9)*nz]
					      -aux[iz+(nx- 8)*nz]*c5*data[iz+(nx- 8)*nz]
					      -aux[iz+(nx- 7)*nz]*c4*data[iz+(nx- 7)*nz]
					      -aux[iz+(nx- 6)*nz]*c3*data[iz+(nx- 6)*nz];
    model[iz+(nx-9)*nz] += aux[iz+(nx-14)*nz]*c1*data[iz+(nx-14)*nz]
					      +aux[iz+(nx-13)*nz]*c2*data[iz+(nx-13)*nz]
					      +aux[iz+(nx-12)*nz]*c3*data[iz+(nx-12)*nz]
					      +aux[iz+(nx-11)*nz]*c4*data[iz+(nx-11)*nz]
					      +aux[iz+(nx-10)*nz]*c5*data[iz+(nx-10)*nz]
					      -aux[iz+(nx- 9)*nz]*c5*data[iz+(nx- 9)*nz]
					      -aux[iz+(nx- 8)*nz]*c4*data[iz+(nx- 8)*nz]
					      -aux[iz+(nx- 7)*nz]*c3*data[iz+(nx- 7)*nz]
					      -aux[iz+(nx- 6)*nz]*c2*data[iz+(nx- 6)*nz];
  }
}

export void Az_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
      foreach(iz=5...(nz-5)) {
        model[iz+i] +=   aux[iz+i-5*nz]*c1*data[iz+i-5*nz]
						+aux[iz+i-4*nz]*c2*data[iz+i-4*nz]
						+aux[iz+i-3*nz]*c3*data[iz+i-3*nz]
						+aux[iz+i-2*nz]*c4*data[iz+i-2*nz]
						+aux[iz+i-  nz]*c5*data[iz+i-  nz]
						-aux[iz+i     ]*c5*data[iz+i     ]
						-aux[iz+i+  nz]*c4*data[iz+i+  nz]
						-aux[iz+i+2*nz]*c3*data[iz+i+2*nz]
						-aux[iz+i+3*nz]*c2*data[iz+i+3*nz]
						-aux[iz+i+4*nz]*c1*data[iz+i+4*nz];
      }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
      foreach(iz=5...(nz-5)) {
        data[iz+i] += aux[iz+i]*(  c1*(-model[iz+i-4*nz])+
								   c2*(-model[iz+i-3*nz])+
								   c3*(-model[iz+i-2*nz])+
								   c4*(-model[iz+i-1*nz])+
								   c5*(-model[iz+i     ])+
								   c5*( model[iz+i+  nz])+
								   c4*( model[iz+i+2*nz])+
								   c3*( model[iz+i+3*nz])+
								   c2*( model[iz+i+4*nz])+
								   c1*( model[iz+i+5*nz]));
	  }
    }
  }
}

export void Bzsides_c_(uniform int add, uniform int nx, uniform int nz, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (add==0) {
    for (uniform int ix=0;ix<nx;ix++) {
      uniform int i=ix*nz;
      for (uniform int iz=0;iz<nz;iz++) {
        model[i+iz]=0.f;
      }
    }
  }
  for (uniform int ix=5;ix<(nx-5);ix++) {
    uniform int i=ix*nz;
    model[i  ] +=-aux[i+5]*c1*data[i+5];
    model[i+1] +=-aux[i+6]*c1*data[i+6]
			     -aux[i+5]*c2*data[i+5];
    model[i+2] +=-aux[i+7]*c1*data[i+7]
			     -aux[i+6]*c2*data[i+6]
			     -aux[i+5]*c3*data[i+5];
    model[i+3] +=-aux[i+8]*c1*data[i+8]
			     -aux[i+7]*c2*data[i+7]
			     -aux[i+6]*c3*data[i+6]
			     -aux[i+5]*c4*data[i+5];
    model[i+4] +=-aux[i+9]*c1*data[i+9]
			     -aux[i+8]*c2*data[i+8]
			     -aux[i+7]*c3*data[i+7]
			     -aux[i+6]*c4*data[i+6]
			     -aux[i+5]*c5*data[i+5];
    model[i+5] +=-aux[i+10]*c1*data[i+10]
			     -aux[i+ 9]*c2*data[i+ 9]
			     -aux[i+ 8]*c3*data[i+ 8]
			     -aux[i+ 7]*c4*data[i+ 7]
			     -aux[i+ 6]*c5*data[i+ 6]
			     +aux[i+ 5]*c5*data[i+ 5];
    model[i+6] +=-aux[i+11]*c1*data[i+11]
			     -aux[i+10]*c2*data[i+10]
			     -aux[i+ 9]*c3*data[i+ 9]
			     -aux[i+ 8]*c4*data[i+ 8]
			     -aux[i+ 7]*c5*data[i+ 7]
			     +aux[i+ 6]*c5*data[i+ 6]
			     +aux[i+ 5]*c4*data[i+ 5];
    model[i+7] +=-aux[i+12]*c1*data[i+12]
			     -aux[i+11]*c2*data[i+11]
			     -aux[i+10]*c3*data[i+10]
			     -aux[i+ 9]*c4*data[i+ 9]
			     -aux[i+ 8]*c5*data[i+ 8]
			     +aux[i+ 7]*c5*data[i+ 7]
			     +aux[i+ 6]*c4*data[i+ 6]
			     +aux[i+ 5]*c3*data[i+ 5];
    model[i+8] +=-aux[i+13]*c1*data[i+13]
			     -aux[i+12]*c2*data[i+12]
			     -aux[i+11]*c3*data[i+11]
			     -aux[i+10]*c4*data[i+10]
			     -aux[i+ 9]*c5*data[i+ 9]
			     +aux[i+ 8]*c5*data[i+ 8]
			     +aux[i+ 7]*c4*data[i+ 7]
			     +aux[i+ 6]*c3*data[i+ 6]
			     +aux[i+ 5]*c2*data[i+ 5];
    model[i+nz-2] += aux[i+nz-6]*c1*data[i+nz-6];
    model[i+nz-3] += aux[i+nz-7]*c1*data[i+nz-7]
			        +aux[i+nz-6]*c2*data[i+nz-6];
    model[i+nz-4] += aux[i+nz-8]*c1*data[i+nz-8]
				 	+aux[i+nz-7]*c2*data[i+nz-7]
				 	+aux[i+nz-6]*c3*data[i+nz-6];
    model[i+nz-5] += aux[i+nz-9]*c1*data[i+nz-9]
				 	+aux[i+nz-8]*c2*data[i+nz-8]
			        +aux[i+nz-7]*c3*data[i+nz-7]
				 	+aux[i+nz-6]*c4*data[i+nz-6];
    model[i+nz-6] += aux[i+nz-10]*c1*data[i+nz-10]
				 	+aux[i+nz- 9]*c2*data[i+nz- 9]
			        +aux[i+nz- 8]*c3*data[i+nz- 8]
			        +aux[i+nz- 7]*c4*data[i+nz- 7]
			        +aux[i+nz- 6]*c5*data[i+nz- 6];
    model[i+nz-7] += aux[i+nz-11]*c1*data[i+nz-11]
			        +aux[i+nz-10]*c2*data[i+nz-10]
			        +aux[i+nz- 9]*c3*data[i+nz- 9]
			        +aux[i+nz- 8]*c4*data[i+nz- 8]
			        +aux[i+nz- 7]*c5*data[i+nz- 7]
			        -aux[i+nz- 6]*c5*data[i+nz- 6];
    model[i+nz-8] += aux[i+nz-12]*c1*data[i+nz-12]
			        +aux[i+nz-11]*c2*data[i+nz-11]
			        +aux[i+nz-10]*c3*data[i+nz-10]
			        +aux[i+nz- 9]*c4*data[i+nz- 9]
			        +aux[i+nz- 8]*c5*data[i+nz- 8]
			        -aux[i+nz- 7]*c5*data[i+nz- 7]
			        -aux[i+nz- 6]*c4*data[i+nz- 6];
    model[i+nz-9] += aux[i+nz-13]*c1*data[i+nz-13]
			        +aux[i+nz-12]*c2*data[i+nz-12]
			        +aux[i+nz-11]*c3*data[i+nz-11]
			        +aux[i+nz-10]*c4*data[i+nz-10]
			        +aux[i+nz- 9]*c5*data[i+nz- 9]
			        -aux[i+nz- 8]*c5*data[i+nz- 8]
			        -aux[i+nz- 7]*c4*data[i+nz- 7]
			        -aux[i+nz- 6]*c3*data[i+nz- 6];
    model[i+nz-10]+= aux[i+nz-14]*c1*data[i+nz-14]
			        +aux[i+nz-13]*c2*data[i+nz-13]
			        +aux[i+nz-12]*c3*data[i+nz-12]
			        +aux[i+nz-11]*c4*data[i+nz-11]
			        +aux[i+nz-10]*c5*data[i+nz-10]
			        -aux[i+nz- 9]*c5*data[i+nz- 9]
			        -aux[i+nz- 8]*c4*data[i+nz- 8]
			        -aux[i+nz- 7]*c3*data[i+nz- 7]
			        -aux[i+nz- 6]*c2*data[i+nz- 6];
  }
}

export void Bz_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
      foreach(iz=9...(nz-10)) {
        model[iz+i] +=   aux[iz+i-4]*c1*data[iz+i-4]
						+aux[iz+i-3]*c2*data[iz+i-3]
						+aux[iz+i-2]*c3*data[iz+i-2]
						+aux[iz+i-1]*c4*data[iz+i-1]
						+aux[iz+i  ]*c5*data[iz+i  ]
						-aux[iz+i+1]*c5*data[iz+i+1]
						-aux[iz+i+2]*c4*data[iz+i+2]
						-aux[iz+i+3]*c3*data[iz+i+3]
						-aux[iz+i+4]*c2*data[iz+i+4]
						-aux[iz+i+5]*c1*data[iz+i+5];
	  }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
      foreach(iz=5...(nz-5)) {
        data[iz+i] += aux[iz+i]*(  c1*(-model[iz+i-5])+
								   c2*(-model[iz+i-4])+
								   c3*(-model[iz+i-3])+
								   c4*(-model[iz+i-2])+
								   c5*(-model[iz+i-1])+
								   c5*( model[iz+i  ])+
								   c4*( model[iz+i+1])+
								   c3*( model[iz+i+2])+
								   c2*( model[iz+i+3])+
								   c1*( model[iz+i+4]));
      }
    }
  }
}

export void Dt_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model1[], uniform float model2[], uniform float data[], uniform float aux) {

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++) {
          model1[iz+i]=0.f;
          model2[iz+i]=0.f;
        }
      }
      foreach(iz=0...nz) {
        model1[iz+i] +=-aux*data[iz+i];
        model2[iz+i] += aux*data[iz+i];
      }
    }
  }
  else {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++) {
	      data[iz+i]=0.f;
        }
      }
      foreach(iz=0...nz) {
        data[iz+i] += aux*(model2[iz+i]-model1[iz+i]);
      }
    }
  }
}

export void dvxdx_c_(uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  for (uniform int ix=bx;ix<ex;ix++) {
	uniform int i=ix*nz;
    if (add==0) {
      for (uniform int iz=0;iz<nz;iz++) {
        data[iz+i]=0.f;
      }
    }
    foreach(iz=5...(nz-5)) {
      data[iz+i] += aux*(c1*(-model[iz+i-4*nz])+
						   c2*(-model[iz+i-3*nz])+
						   c3*(-model[iz+i-2*nz])+
						   c4*(-model[iz+i-1*nz])+
						   c5*(-model[iz+i     ])+
						   c5*( model[iz+i+  nz])+
						   c4*( model[iz+i+2*nz])+
						   c3*( model[iz+i+3*nz])+
						   c2*( model[iz+i+4*nz])+
						   c1*( model[iz+i+5*nz]));
	}
  }
}

export void dvzdx_c_(uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  for (uniform int ix=bx;ix<ex;ix++) {
	uniform int i=ix*nz;
    if (add==0) {
      for (uniform int iz=0;iz<nz;iz++){
        data[iz+i]=0.f;
      }
    }
    foreach(iz=5...(nz-5)) {
      data[iz+i] += aux*(c1*(  -model[iz+i-5*nz])+
						   c2*(-model[iz+i-4*nz])+
						   c3*(-model[iz+i-3*nz])+
						   c4*(-model[iz+i-2*nz])+
						   c5*(-model[iz+i-  nz])+
						   c5*( model[iz+i     ])+
						   c4*( model[iz+i+  nz])+
						   c3*( model[iz+i+2*nz])+
						   c2*( model[iz+i+3*nz])+
						   c1*( model[iz+i+4*nz]));
	}
  }
}

export void dvzdz_c_(uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  for (uniform int ix=bx;ix<ex;ix++) {
	uniform int i=ix*nz;
    if (add==0) {
      for (uniform int iz=0;iz<nz;iz++) {
        data[iz+i]=0.f;
      }
    }
    foreach(iz=5...(nz-5)) {
      data[iz+i] += aux*(  c1*(-model[iz+i-4])+
						   c2*(-model[iz+i-3])+
						   c3*(-model[iz+i-2])+
						   c4*(-model[iz+i-1])+
						   c5*(-model[iz+i  ])+
						   c5*( model[iz+i+1])+
						   c4*( model[iz+i+2])+
						   c3*( model[iz+i+3])+
						   c2*( model[iz+i+4])+
						   c1*( model[iz+i+5]));
	}
  }
}

export void dvxdz_c_(uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  for (uniform int ix=bx;ix<ex;ix++) {
	uniform int i=ix*nz;
    if (add==0) {
      for (uniform int iz=0;iz<nz;iz++) {
	    data[iz+i]=0.f;
      }
    }
    foreach(iz=5...(nz-5)) {
      data[iz+i] += aux*(  c1*(-model[iz+i-5])+
						   c2*(-model[iz+i-4])+
						   c3*(-model[iz+i-3])+
						   c4*(-model[iz+i-2])+
						   c5*(-model[iz+i-1])+
						   c5*( model[iz+i  ])+
						   c4*( model[iz+i+1])+
						   c3*( model[iz+i+2])+
						   c2*( model[iz+i+3])+
						   c1*( model[iz+i+4]));
	}
  }
}

export void Zero_array_c_(uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float array[]){

  for (uniform int ix=bx;ix<ex;ix++) {
	uniform int i=ix*nz;
	for (uniform int iz=0;iz<nz;iz++) {
      array[iz+i]=0.f;
    }
  }
}

export void Axb_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
	  foreach(iz=5...(nz-5)) {
    	model[iz+i] +=	-aux[iz+i-4*nz]*c1*data[iz+i-4*nz]
						-aux[iz+i-3*nz]*c2*data[iz+i-3*nz]
				  		-aux[iz+i-2*nz]*c3*data[iz+i-2*nz]
				  		-aux[iz+i-  nz]*c4*data[iz+i-  nz]
				  		-aux[iz+i     ]*c5*data[iz+i     ]
				  		+aux[iz+i+  nz]*c5*data[iz+i+  nz]
						+aux[iz+i+2*nz]*c4*data[iz+i+2*nz]
						+aux[iz+i+3*nz]*c3*data[iz+i+3*nz]
						+aux[iz+i+4*nz]*c2*data[iz+i+4*nz]
						+aux[iz+i+5*nz]*c1*data[iz+i+5*nz];
      }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
	  foreach(iz=5...(nz-5)) {
		data[iz+i] +=  -aux[iz+i]*(c1*(-model[iz+i-5*nz])+
							   	   c2*(-model[iz+i-4*nz])+
								   c3*(-model[iz+i-3*nz])+
								   c4*(-model[iz+i-2*nz])+
								   c5*(-model[iz+i-  nz])+
								   c5*( model[iz+i     ])+
								   c4*( model[iz+i+  nz])+
								   c3*( model[iz+i+2*nz])+
								   c2*( model[iz+i+3*nz])+
								   c1*( model[iz+i+4*nz]));
	  }
    }
  }
}

export void Bxb_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
      foreach(iz=10...(nz-9)) {
        model[iz+i] += 	-aux[iz+i-5]*c1*data[iz+i-5]
					  	-aux[iz+i-4]*c2*data[iz+i-4]
				  		-aux[iz+i-3]*c3*data[iz+i-3]
						-aux[iz+i-2]*c4*data[iz+i-2]
						-aux[iz+i-1]*c5*data[iz+i-1]
						+aux[iz+i  ]*c5*data[iz+i  ]
						+aux[iz+i+1]*c4*data[iz+i+1]
						+aux[iz+i+2]*c3*data[iz+i+2]
						+aux[iz+i+3]*c2*data[iz+i+3]
						+aux[iz+i+4]*c1*data[iz+i+4];
      }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
      foreach(iz=5...(nz-5)) {
        data[iz+i] += -aux[iz+i]*( c1*(-model[iz+i-4])+
								   c2*(-model[iz+i-3])+
								   c3*(-model[iz+i-2])+
								   c4*(-model[iz+i-1])+
								   c5*(-model[iz+i  ])+
								   c5*( model[iz+i+1])+
								   c4*( model[iz+i+2])+
								   c3*( model[iz+i+3])+
								   c2*( model[iz+i+4])+
								   c1*( model[iz+i+5]));
      }
    }
  }
}

export void Azb_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
      foreach(iz=5...(nz-5)) {
        model[iz+i] +=  -aux[iz+i-5*nz]*c1*data[iz+i-5*nz]
						-aux[iz+i-4*nz]*c2*data[iz+i-4*nz]
						-aux[iz+i-3*nz]*c3*data[iz+i-3*nz]
						-aux[iz+i-2*nz]*c4*data[iz+i-2*nz]
						-aux[iz+i-  nz]*c5*data[iz+i-  nz]
						+aux[iz+i     ]*c5*data[iz+i     ]
						+aux[iz+i+  nz]*c4*data[iz+i+  nz]
						+aux[iz+i+2*nz]*c3*data[iz+i+2*nz]
						+aux[iz+i+3*nz]*c2*data[iz+i+3*nz]
						+aux[iz+i+4*nz]*c1*data[iz+i+4*nz];
      }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
      foreach(iz=5...(nz-5)) {
        data[iz+i] += -aux[iz+i]*( c1*(-model[iz+i-4*nz])+
								   c2*(-model[iz+i-3*nz])+
								   c3*(-model[iz+i-2*nz])+
								   c4*(-model[iz+i-1*nz])+
								   c5*(-model[iz+i     ])+
								   c5*( model[iz+i+  nz])+
								   c4*( model[iz+i+2*nz])+
								   c3*( model[iz+i+3*nz])+
								   c2*( model[iz+i+4*nz])+
								   c1*( model[iz+i+5*nz]));
	  }
    }
  }
}

export void Bzb_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform float model[], uniform float data[], uniform float aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
      foreach(iz=9...(nz-10)) {
        model[iz+i] +=  -aux[iz+i-4]*c1*data[iz+i-4]
						-aux[iz+i-3]*c2*data[iz+i-3]
						-aux[iz+i-2]*c3*data[iz+i-2]
						-aux[iz+i-1]*c4*data[iz+i-1]
						-aux[iz+i  ]*c5*data[iz+i  ]
						+aux[iz+i+1]*c5*data[iz+i+1]
						+aux[iz+i+2]*c4*data[iz+i+2]
						+aux[iz+i+3]*c3*data[iz+i+3]
						+aux[iz+i+4]*c2*data[iz+i+4]
						+aux[iz+i+5]*c1*data[iz+i+5];
	  }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
      foreach(iz=5...(nz-5)) {
        data[iz+i] += -aux[iz+i]*( c1*(-model[iz+i-5])+
								   c2*(-model[iz+i-4])+
								   c3*(-model[iz+i-3])+
								   c4*(-model[iz+i-2])+
								   c5*(-model[iz+i-1])+
								   c5*( model[iz+i  ])+
								   c4*( model[iz+i+1])+
								   c3*( model[iz+i+2])+
								   c2*( model[iz+i+3])+
								   c1*( model[iz+i+4]));
      }
    }
  }
}

//################################################//
//########       DOUBLE PRECISION    #############//
//################################################//

export void Axsides_double_c_(uniform int add, uniform int nx, uniform int nz, uniform double model[], uniform double data[], uniform double aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (add==0) {
    for (uniform int ix=0;ix<nx;ix++) {
      uniform int i=ix*nz;
      for (uniform int iz=0;iz<nz;iz++){
        model[iz+i]=0.f;
      }
    }
  }
  foreach(iz=5...(nz-5)) {
    model[iz     ] +=-aux[iz+5*nz]*c1*data[iz+5*nz];
    model[iz+  nz] +=-aux[iz+6*nz]*c1*data[iz+6*nz]
			         -aux[iz+5*nz]*c2*data[iz+5*nz];
    model[iz+2*nz] +=-aux[iz+7*nz]*c1*data[iz+7*nz]
			         -aux[iz+6*nz]*c2*data[iz+6*nz]
			         -aux[iz+5*nz]*c3*data[iz+5*nz];
    model[iz+3*nz] +=-aux[iz+8*nz]*c1*data[iz+8*nz]
			         -aux[iz+7*nz]*c2*data[iz+7*nz]
			         -aux[iz+6*nz]*c3*data[iz+6*nz]
			         -aux[iz+5*nz]*c4*data[iz+5*nz];
    model[iz+4*nz] +=-aux[iz+9*nz]*c1*data[iz+9*nz]
			         -aux[iz+8*nz]*c2*data[iz+8*nz]
			         -aux[iz+7*nz]*c3*data[iz+7*nz]
			         -aux[iz+6*nz]*c4*data[iz+6*nz]
			         -aux[iz+5*nz]*c5*data[iz+5*nz];
    model[iz+5*nz] +=-aux[iz+10*nz]*c1*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c2*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c3*data[iz+ 8*nz]
			         -aux[iz+ 7*nz]*c4*data[iz+ 7*nz]
			         -aux[iz+ 6*nz]*c5*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c5*data[iz+ 5*nz];
    model[iz+6*nz] +=-aux[iz+11*nz]*c1*data[iz+11*nz]
			         -aux[iz+10*nz]*c2*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c3*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c4*data[iz+ 8*nz]
			         -aux[iz+ 7*nz]*c5*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c5*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c4*data[iz+ 5*nz];
    model[iz+7*nz] +=-aux[iz+12*nz]*c1*data[iz+12*nz]
			         -aux[iz+11*nz]*c2*data[iz+11*nz]
			         -aux[iz+10*nz]*c3*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c4*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c5*data[iz+ 8*nz]
			         +aux[iz+ 7*nz]*c5*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c4*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c3*data[iz+ 5*nz];
    model[iz+8*nz] +=-aux[iz+13*nz]*c1*data[iz+13*nz]
			         -aux[iz+12*nz]*c2*data[iz+12*nz]
			         -aux[iz+11*nz]*c3*data[iz+11*nz]
			         -aux[iz+10*nz]*c4*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c5*data[iz+ 9*nz]
			         +aux[iz+ 8*nz]*c5*data[iz+ 8*nz]
			         +aux[iz+ 7*nz]*c4*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c3*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c2*data[iz+ 5*nz];
    model[iz+(nx-2)*nz] += aux[iz+(nx-6)*nz]*c1*data[iz+(nx-6)*nz];
    model[iz+(nx-3)*nz] += aux[iz+(nx-7)*nz]*c1*data[iz+(nx-7)*nz]
						  +aux[iz+(nx-6)*nz]*c2*data[iz+(nx-6)*nz];
    model[iz+(nx-4)*nz] += aux[iz+(nx-8)*nz]*c1*data[iz+(nx-8)*nz]
						  +aux[iz+(nx-7)*nz]*c2*data[iz+(nx-7)*nz]
						  +aux[iz+(nx-6)*nz]*c3*data[iz+(nx-6)*nz];
    model[iz+(nx-5)*nz] += aux[iz+(nx-9)*nz]*c1*data[iz+(nx-9)*nz]
						  +aux[iz+(nx-8)*nz]*c2*data[iz+(nx-8)*nz]
						  +aux[iz+(nx-7)*nz]*c3*data[iz+(nx-7)*nz]
						  +aux[iz+(nx-6)*nz]*c4*data[iz+(nx-6)*nz];
    model[iz+(nx-6)*nz] += aux[iz+(nx-10)*nz]*c1*data[iz+(nx-10)*nz]
						  +aux[iz+(nx- 9)*nz]*c2*data[iz+(nx- 9)*nz]
						  +aux[iz+(nx- 8)*nz]*c3*data[iz+(nx- 8)*nz]
						  +aux[iz+(nx- 7)*nz]*c4*data[iz+(nx- 7)*nz]
						  +aux[iz+(nx- 6)*nz]*c5*data[iz+(nx- 6)*nz];
    model[iz+(nx-7)*nz] += aux[iz+(nx-11)*nz]*c1*data[iz+(nx-11)*nz]
						  +aux[iz+(nx-10)*nz]*c2*data[iz+(nx-10)*nz]
						  +aux[iz+(nx- 9)*nz]*c3*data[iz+(nx- 9)*nz]
						  +aux[iz+(nx- 8)*nz]*c4*data[iz+(nx- 8)*nz]
						  +aux[iz+(nx- 7)*nz]*c5*data[iz+(nx- 7)*nz]
						  -aux[iz+(nx- 6)*nz]*c5*data[iz+(nx- 6)*nz];
    model[iz+(nx-8)*nz] += aux[iz+(nx-12)*nz]*c1*data[iz+(nx-12)*nz]
						  +aux[iz+(nx-11)*nz]*c2*data[iz+(nx-11)*nz]
						  +aux[iz+(nx-10)*nz]*c3*data[iz+(nx-10)*nz]
						  +aux[iz+(nx- 9)*nz]*c4*data[iz+(nx- 9)*nz]
						  +aux[iz+(nx- 8)*nz]*c5*data[iz+(nx- 8)*nz]
						  -aux[iz+(nx- 7)*nz]*c5*data[iz+(nx- 7)*nz]
						  -aux[iz+(nx- 6)*nz]*c4*data[iz+(nx- 6)*nz];
    model[iz+(nx-9)*nz] += aux[iz+(nx-13)*nz]*c1*data[iz+(nx-13)*nz]
						  +aux[iz+(nx-12)*nz]*c2*data[iz+(nx-12)*nz]
						  +aux[iz+(nx-11)*nz]*c3*data[iz+(nx-11)*nz]
						  +aux[iz+(nx-10)*nz]*c4*data[iz+(nx-10)*nz]
						  +aux[iz+(nx- 9)*nz]*c5*data[iz+(nx- 9)*nz]
						  -aux[iz+(nx- 8)*nz]*c5*data[iz+(nx- 8)*nz]
						  -aux[iz+(nx- 7)*nz]*c4*data[iz+(nx- 7)*nz]
						  -aux[iz+(nx- 6)*nz]*c3*data[iz+(nx- 6)*nz];
    model[iz+(nx-10)*nz] += aux[iz+(nx-14)*nz]*c1*data[iz+(nx-14)*nz]
						   +aux[iz+(nx-13)*nz]*c2*data[iz+(nx-13)*nz]
						   +aux[iz+(nx-12)*nz]*c3*data[iz+(nx-12)*nz]
						   +aux[iz+(nx-11)*nz]*c4*data[iz+(nx-11)*nz]
						   +aux[iz+(nx-10)*nz]*c5*data[iz+(nx-10)*nz]
						   -aux[iz+(nx- 9)*nz]*c5*data[iz+(nx- 9)*nz]
						   -aux[iz+(nx- 8)*nz]*c4*data[iz+(nx- 8)*nz]
						   -aux[iz+(nx- 7)*nz]*c3*data[iz+(nx- 7)*nz]
						   -aux[iz+(nx- 6)*nz]*c2*data[iz+(nx- 6)*nz];
  }
}

export void Ax_double_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform double model[], uniform double data[], uniform double aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
	  foreach(iz=5...(nz-5)) {
    	model[iz+i] +=	 aux[iz+i-4*nz]*c1*data[iz+i-4*nz]
						+aux[iz+i-3*nz]*c2*data[iz+i-3*nz]
				  		+aux[iz+i-2*nz]*c3*data[iz+i-2*nz]
				  		+aux[iz+i-  nz]*c4*data[iz+i-  nz]
				  		+aux[iz+i     ]*c5*data[iz+i     ]
				  		-aux[iz+i+  nz]*c5*data[iz+i+  nz]
						-aux[iz+i+2*nz]*c4*data[iz+i+2*nz]
						-aux[iz+i+3*nz]*c3*data[iz+i+3*nz]
						-aux[iz+i+4*nz]*c2*data[iz+i+4*nz]
						-aux[iz+i+5*nz]*c1*data[iz+i+5*nz];
      }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
	  foreach(iz=5...(nz-5)) {
		data[iz+i] += 	aux[iz+i]*(c1*(-model[iz+i-5*nz])+
							   	   c2*(-model[iz+i-4*nz])+
								   c3*(-model[iz+i-3*nz])+
								   c4*(-model[iz+i-2*nz])+
								   c5*(-model[iz+i-  nz])+
								   c5*( model[iz+i     ])+
								   c4*( model[iz+i+  nz])+
								   c3*( model[iz+i+2*nz])+
								   c2*( model[iz+i+3*nz])+
								   c1*( model[iz+i+4*nz]));
	  }
    }
  }
}

export void Bxsides_double_c_(uniform int add, uniform int nx, uniform int nz, uniform double model[], uniform double data[], uniform double aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (add==0) {
    for (uniform int ix=0;ix<nx;ix++){
      uniform int i=ix*nz;
      for (uniform int iz=0;iz<nz;iz++){
        model[i+iz]=0.f;
      }
    }
  }
  for (uniform int ix=5;ix<(nx-5);ix++) {
    uniform int i=ix*nz;
    model[i+1] +=-aux[i+5]*c1*data[i+5];
    model[i+2] +=-aux[i+6]*c1*data[i+6]
			     -aux[i+5]*c2*data[i+5];
    model[i+3] +=-aux[i+7]*c1*data[i+7]
			     -aux[i+6]*c2*data[i+6]
			     -aux[i+5]*c3*data[i+5];
    model[i+4] +=-aux[i+8]*c1*data[i+8]
			     -aux[i+7]*c2*data[i+7]
			     -aux[i+6]*c3*data[i+6]
			     -aux[i+5]*c4*data[i+5];
    model[i+5] +=-aux[i+9]*c1*data[i+9]
			     -aux[i+8]*c2*data[i+8]
			     -aux[i+7]*c3*data[i+7]
			     -aux[i+6]*c4*data[i+6]
			     -aux[i+5]*c5*data[i+5];
    model[i+6] +=-aux[i+10]*c1*data[i+10]
			     -aux[i+ 9]*c2*data[i+ 9]
			     -aux[i+ 8]*c3*data[i+ 8]
			     -aux[i+ 7]*c4*data[i+ 7]
			     -aux[i+ 6]*c5*data[i+ 6]
			     +aux[i+ 5]*c5*data[i+ 5];
    model[i+7] +=-aux[i+11]*c1*data[i+11]
			     -aux[i+10]*c2*data[i+10]
			     -aux[i+ 9]*c3*data[i+ 9]
			     -aux[i+ 8]*c4*data[i+ 8]
			     -aux[i+ 7]*c5*data[i+ 7]
			     +aux[i+ 6]*c5*data[i+ 6]
			     +aux[i+ 5]*c4*data[i+ 5];
    model[i+8] +=-aux[i+12]*c1*data[i+12]
			     -aux[i+11]*c2*data[i+11]
			     -aux[i+10]*c3*data[i+10]
			     -aux[i+ 9]*c4*data[i+ 9]
			     -aux[i+ 8]*c5*data[i+ 8]
			     +aux[i+ 7]*c5*data[i+ 7]
			     +aux[i+ 6]*c4*data[i+ 6]
			     +aux[i+ 5]*c3*data[i+ 5];
    model[i+9] +=-aux[i+13]*c1*data[i+13]
			     -aux[i+12]*c2*data[i+12]
			     -aux[i+11]*c3*data[i+11]
			     -aux[i+10]*c4*data[i+10]
			     -aux[i+ 9]*c5*data[i+ 9]
			     +aux[i+ 8]*c5*data[i+ 8]
			     +aux[i+ 7]*c4*data[i+ 7]
			     +aux[i+ 6]*c3*data[i+ 6]
			     +aux[i+ 5]*c2*data[i+ 5];
    model[i+nz-1] += aux[i+nz-6]*c1*data[i+nz-6];
    model[i+nz-2] += aux[i+nz-7]*c1*data[i+nz-7]
			        +aux[i+nz-6]*c2*data[i+nz-6];
    model[i+nz-3] += aux[i+nz-8]*c1*data[i+nz-8]
				 	+aux[i+nz-7]*c2*data[i+nz-7]
				 	+aux[i+nz-6]*c3*data[i+nz-6];
    model[i+nz-4] += aux[i+nz-9]*c1*data[i+nz-9]
				 	+aux[i+nz-8]*c2*data[i+nz-8]
			        +aux[i+nz-7]*c3*data[i+nz-7]
				 	+aux[i+nz-6]*c4*data[i+nz-6];
    model[i+nz-5] += aux[i+nz-10]*c1*data[i+nz-10]
				 	+aux[i+nz- 9]*c2*data[i+nz- 9]
			        +aux[i+nz- 8]*c3*data[i+nz- 8]
			        +aux[i+nz- 7]*c4*data[i+nz- 7]
			        +aux[i+nz- 6]*c5*data[i+nz- 6];
    model[i+nz-6] += aux[i+nz-11]*c1*data[i+nz-11]
			        +aux[i+nz-10]*c2*data[i+nz-10]
			        +aux[i+nz- 9]*c3*data[i+nz- 9]
			        +aux[i+nz- 8]*c4*data[i+nz- 8]
			        +aux[i+nz- 7]*c5*data[i+nz- 7]
			        -aux[i+nz- 6]*c5*data[i+nz- 6];
    model[i+nz-7] += aux[i+nz-12]*c1*data[i+nz-12]
			        +aux[i+nz-11]*c2*data[i+nz-11]
			        +aux[i+nz-10]*c3*data[i+nz-10]
			        +aux[i+nz- 9]*c4*data[i+nz- 9]
			        +aux[i+nz- 8]*c5*data[i+nz- 8]
			        -aux[i+nz- 7]*c5*data[i+nz- 7]
			        -aux[i+nz- 6]*c4*data[i+nz- 6];
    model[i+nz-8] += aux[i+nz-13]*c1*data[i+nz-13]
			        +aux[i+nz-12]*c2*data[i+nz-12]
			        +aux[i+nz-11]*c3*data[i+nz-11]
			        +aux[i+nz-10]*c4*data[i+nz-10]
			        +aux[i+nz- 9]*c5*data[i+nz- 9]
			        -aux[i+nz- 8]*c5*data[i+nz- 8]
			        -aux[i+nz- 7]*c4*data[i+nz- 7]
			        -aux[i+nz- 6]*c3*data[i+nz- 6];
    model[i+nz-9] += aux[i+nz-14]*c1*data[i+nz-14]
				    +aux[i+nz-13]*c2*data[i+nz-13]
			     	+aux[i+nz-12]*c3*data[i+nz-12]
			        +aux[i+nz-11]*c4*data[i+nz-11]
			        +aux[i+nz-10]*c5*data[i+nz-10]
			        -aux[i+nz- 9]*c5*data[i+nz- 9]
			        -aux[i+nz- 8]*c4*data[i+nz- 8]
			        -aux[i+nz- 7]*c3*data[i+nz- 7]
			        -aux[i+nz- 6]*c2*data[i+nz- 6];
  }
}
export void Bx_double_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform double model[], uniform double data[], uniform double aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
      foreach(iz=10...(nz-9)) {
        model[iz+i] += 	 aux[iz+i-5]*c1*data[iz+i-5]
					  	+aux[iz+i-4]*c2*data[iz+i-4]
				  		+aux[iz+i-3]*c3*data[iz+i-3]
						+aux[iz+i-2]*c4*data[iz+i-2]
						+aux[iz+i-1]*c5*data[iz+i-1]
						-aux[iz+i  ]*c5*data[iz+i  ]
						-aux[iz+i+1]*c4*data[iz+i+1]
						-aux[iz+i+2]*c3*data[iz+i+2]
						-aux[iz+i+3]*c2*data[iz+i+3]
						-aux[iz+i+4]*c1*data[iz+i+4];
      }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
      foreach(iz=5...(nz-5)) {
        data[iz+i] += aux[iz+i]*(  c1*(-model[iz+i-4])+
								   c2*(-model[iz+i-3])+
								   c3*(-model[iz+i-2])+
								   c4*(-model[iz+i-1])+
								   c5*(-model[iz+i  ])+
								   c5*( model[iz+i+1])+
								   c4*( model[iz+i+2])+
								   c3*( model[iz+i+3])+
								   c2*( model[iz+i+4])+
								   c1*( model[iz+i+5]));
      }
    }
  }
}

export void Azsides_double_c_(uniform int add, uniform int nx, uniform int nz, uniform double model[], uniform double data[], uniform double aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (add==0) {
    for (uniform int ix=0;ix<nx;ix++) {
      uniform int i=ix*nz;
      for (uniform int iz=0;iz<nz;iz++) {
        model[iz+i]=0.f;
      }
    }
  }
  foreach(iz=5...(nz-5)) {
    model[iz+  nz] +=-aux[iz+5*nz]*c1*data[iz+5*nz];
    model[iz+2*nz] +=-aux[iz+6*nz]*c1*data[iz+6*nz]
			         -aux[iz+5*nz]*c2*data[iz+5*nz];
    model[iz+3*nz] +=-aux[iz+7*nz]*c1*data[iz+7*nz]
			         -aux[iz+6*nz]*c2*data[iz+6*nz]
			         -aux[iz+5*nz]*c3*data[iz+5*nz];
    model[iz+4*nz] +=-aux[iz+8*nz]*c1*data[iz+8*nz]
			         -aux[iz+7*nz]*c2*data[iz+7*nz]
			         -aux[iz+6*nz]*c3*data[iz+6*nz]
			         -aux[iz+5*nz]*c4*data[iz+5*nz];
    model[iz+5*nz] +=-aux[iz+9*nz]*c1*data[iz+9*nz]
			         -aux[iz+8*nz]*c2*data[iz+8*nz]
			         -aux[iz+7*nz]*c3*data[iz+7*nz]
			         -aux[iz+6*nz]*c4*data[iz+6*nz]
			         -aux[iz+5*nz]*c5*data[iz+5*nz];
    model[iz+6*nz] +=-aux[iz+10*nz]*c1*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c2*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c3*data[iz+ 8*nz]
			         -aux[iz+ 7*nz]*c4*data[iz+ 7*nz]
			         -aux[iz+ 6*nz]*c5*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c5*data[iz+ 5*nz];
    model[iz+7*nz] +=-aux[iz+11*nz]*c1*data[iz+11*nz]
			         -aux[iz+10*nz]*c2*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c3*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c4*data[iz+ 8*nz]
			         -aux[iz+ 7*nz]*c5*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c5*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c4*data[iz+ 5*nz];
    model[iz+8*nz] +=-aux[iz+12*nz]*c1*data[iz+12*nz]
			         -aux[iz+11*nz]*c2*data[iz+11*nz]
			         -aux[iz+10*nz]*c3*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c4*data[iz+ 9*nz]
			         -aux[iz+ 8*nz]*c5*data[iz+ 8*nz]
			         +aux[iz+ 7*nz]*c5*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c4*data[iz+ 6*nz]
			         +aux[iz+ 5*nz]*c3*data[iz+ 5*nz];
    model[iz+9*nz] +=-aux[iz+13*nz]*c1*data[iz+13*nz]
			         -aux[iz+12*nz]*c2*data[iz+12*nz]
			         -aux[iz+11*nz]*c3*data[iz+11*nz]
			         -aux[iz+10*nz]*c4*data[iz+10*nz]
			         -aux[iz+ 9*nz]*c5*data[iz+ 9*nz]
			         +aux[iz+ 8*nz]*c5*data[iz+ 8*nz]
			         +aux[iz+ 7*nz]*c4*data[iz+ 7*nz]
			         +aux[iz+ 6*nz]*c3*data[iz+ 6*nz]			         
			         +aux[iz+ 5*nz]*c2*data[iz+ 5*nz];
    model[iz+(nx-1)*nz] += aux[iz+(nx-6)*nz]*c1*data[iz+(nx-6)*nz];
    model[iz+(nx-2)*nz] += aux[iz+(nx-7)*nz]*c1*data[iz+(nx-7)*nz]
					      +aux[iz+(nx-6)*nz]*c2*data[iz+(nx-6)*nz];
    model[iz+(nx-3)*nz] += aux[iz+(nx-8)*nz]*c1*data[iz+(nx-8)*nz]
					      +aux[iz+(nx-7)*nz]*c2*data[iz+(nx-7)*nz]
					      +aux[iz+(nx-6)*nz]*c3*data[iz+(nx-6)*nz];
    model[iz+(nx-4)*nz] += aux[iz+(nx-9)*nz]*c1*data[iz+(nx-9)*nz]
					      +aux[iz+(nx-8)*nz]*c2*data[iz+(nx-8)*nz]
					      +aux[iz+(nx-7)*nz]*c3*data[iz+(nx-7)*nz]
					      +aux[iz+(nx-6)*nz]*c4*data[iz+(nx-6)*nz];
    model[iz+(nx-5)*nz] += aux[iz+(nx-10)*nz]*c1*data[iz+(nx-10)*nz]
					      +aux[iz+(nx- 9)*nz]*c2*data[iz+(nx- 9)*nz]
					      +aux[iz+(nx- 8)*nz]*c3*data[iz+(nx- 8)*nz]
					      +aux[iz+(nx- 7)*nz]*c4*data[iz+(nx- 7)*nz]
					      +aux[iz+(nx- 6)*nz]*c5*data[iz+(nx- 6)*nz];
    model[iz+(nx-6)*nz] += aux[iz+(nx-11)*nz]*c1*data[iz+(nx-11)*nz]
					      +aux[iz+(nx-10)*nz]*c2*data[iz+(nx-10)*nz]
					      +aux[iz+(nx- 9)*nz]*c3*data[iz+(nx- 9)*nz]
					      +aux[iz+(nx- 8)*nz]*c4*data[iz+(nx- 8)*nz]
					      +aux[iz+(nx- 7)*nz]*c5*data[iz+(nx- 7)*nz]
					      -aux[iz+(nx- 6)*nz]*c5*data[iz+(nx- 6)*nz];
    model[iz+(nx-7)*nz] += aux[iz+(nx-12)*nz]*c1*data[iz+(nx-12)*nz]
					      +aux[iz+(nx-11)*nz]*c2*data[iz+(nx-11)*nz]
					      +aux[iz+(nx-10)*nz]*c3*data[iz+(nx-10)*nz]
					      +aux[iz+(nx- 9)*nz]*c4*data[iz+(nx- 9)*nz]
					      +aux[iz+(nx- 8)*nz]*c5*data[iz+(nx- 8)*nz]
					      -aux[iz+(nx- 7)*nz]*c5*data[iz+(nx- 7)*nz]
					      -aux[iz+(nx- 6)*nz]*c4*data[iz+(nx- 6)*nz];
    model[iz+(nx-8)*nz] += aux[iz+(nx-13)*nz]*c1*data[iz+(nx-13)*nz]
				          +aux[iz+(nx-12)*nz]*c2*data[iz+(nx-12)*nz]
					      +aux[iz+(nx-11)*nz]*c3*data[iz+(nx-11)*nz]
					      +aux[iz+(nx-10)*nz]*c4*data[iz+(nx-10)*nz]
					      +aux[iz+(nx- 9)*nz]*c5*data[iz+(nx- 9)*nz]
					      -aux[iz+(nx- 8)*nz]*c5*data[iz+(nx- 8)*nz]
					      -aux[iz+(nx- 7)*nz]*c4*data[iz+(nx- 7)*nz]
					      -aux[iz+(nx- 6)*nz]*c3*data[iz+(nx- 6)*nz];
    model[iz+(nx-9)*nz] += aux[iz+(nx-14)*nz]*c1*data[iz+(nx-14)*nz]
					      +aux[iz+(nx-13)*nz]*c2*data[iz+(nx-13)*nz]
					      +aux[iz+(nx-12)*nz]*c3*data[iz+(nx-12)*nz]
					      +aux[iz+(nx-11)*nz]*c4*data[iz+(nx-11)*nz]
					      +aux[iz+(nx-10)*nz]*c5*data[iz+(nx-10)*nz]
					      -aux[iz+(nx- 9)*nz]*c5*data[iz+(nx- 9)*nz]
					      -aux[iz+(nx- 8)*nz]*c4*data[iz+(nx- 8)*nz]
					      -aux[iz+(nx- 7)*nz]*c3*data[iz+(nx- 7)*nz]
					      -aux[iz+(nx- 6)*nz]*c2*data[iz+(nx- 6)*nz];
  }
}

export void Az_double_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform double model[], uniform double data[], uniform double aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
      foreach(iz=5...(nz-5)) {
        model[iz+i] +=   aux[iz+i-5*nz]*c1*data[iz+i-5*nz]
						+aux[iz+i-4*nz]*c2*data[iz+i-4*nz]
						+aux[iz+i-3*nz]*c3*data[iz+i-3*nz]
						+aux[iz+i-2*nz]*c4*data[iz+i-2*nz]
						+aux[iz+i-  nz]*c5*data[iz+i-  nz]
						-aux[iz+i     ]*c5*data[iz+i     ]
						-aux[iz+i+  nz]*c4*data[iz+i+  nz]
						-aux[iz+i+2*nz]*c3*data[iz+i+2*nz]
						-aux[iz+i+3*nz]*c2*data[iz+i+3*nz]
						-aux[iz+i+4*nz]*c1*data[iz+i+4*nz];
      }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
      foreach(iz=5...(nz-5)) {
        data[iz+i] += aux[iz+i]*(  c1*(-model[iz+i-4*nz])+
								   c2*(-model[iz+i-3*nz])+
								   c3*(-model[iz+i-2*nz])+
								   c4*(-model[iz+i-1*nz])+
								   c5*(-model[iz+i     ])+
								   c5*( model[iz+i+  nz])+
								   c4*( model[iz+i+2*nz])+
								   c3*( model[iz+i+3*nz])+
								   c2*( model[iz+i+4*nz])+
								   c1*( model[iz+i+5*nz]));
	  }
    }
  }
}

export void Bzsides_double_c_(uniform int add, uniform int nx, uniform int nz, uniform double model[], uniform double data[], uniform double aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (add==0) {
    for (uniform int ix=0;ix<nx;ix++) {
      uniform int i=ix*nz;
      for (uniform int iz=0;iz<nz;iz++) {
        model[i+iz]=0.f;
      }
    }
  }
  for (uniform int ix=5;ix<(nx-5);ix++) {
    uniform int i=ix*nz;
    model[i  ] +=-aux[i+5]*c1*data[i+5];
    model[i+1] +=-aux[i+6]*c1*data[i+6]
			     -aux[i+5]*c2*data[i+5];
    model[i+2] +=-aux[i+7]*c1*data[i+7]
			     -aux[i+6]*c2*data[i+6]
			     -aux[i+5]*c3*data[i+5];
    model[i+3] +=-aux[i+8]*c1*data[i+8]
			     -aux[i+7]*c2*data[i+7]
			     -aux[i+6]*c3*data[i+6]
			     -aux[i+5]*c4*data[i+5];
    model[i+4] +=-aux[i+9]*c1*data[i+9]
			     -aux[i+8]*c2*data[i+8]
			     -aux[i+7]*c3*data[i+7]
			     -aux[i+6]*c4*data[i+6]
			     -aux[i+5]*c5*data[i+5];
    model[i+5] +=-aux[i+10]*c1*data[i+10]
			     -aux[i+ 9]*c2*data[i+ 9]
			     -aux[i+ 8]*c3*data[i+ 8]
			     -aux[i+ 7]*c4*data[i+ 7]
			     -aux[i+ 6]*c5*data[i+ 6]
			     +aux[i+ 5]*c5*data[i+ 5];
    model[i+6] +=-aux[i+11]*c1*data[i+11]
			     -aux[i+10]*c2*data[i+10]
			     -aux[i+ 9]*c3*data[i+ 9]
			     -aux[i+ 8]*c4*data[i+ 8]
			     -aux[i+ 7]*c5*data[i+ 7]
			     +aux[i+ 6]*c5*data[i+ 6]
			     +aux[i+ 5]*c4*data[i+ 5];
    model[i+7] +=-aux[i+12]*c1*data[i+12]
			     -aux[i+11]*c2*data[i+11]
			     -aux[i+10]*c3*data[i+10]
			     -aux[i+ 9]*c4*data[i+ 9]
			     -aux[i+ 8]*c5*data[i+ 8]
			     +aux[i+ 7]*c5*data[i+ 7]
			     +aux[i+ 6]*c4*data[i+ 6]
			     +aux[i+ 5]*c3*data[i+ 5];
    model[i+8] +=-aux[i+13]*c1*data[i+13]
			     -aux[i+12]*c2*data[i+12]
			     -aux[i+11]*c3*data[i+11]
			     -aux[i+10]*c4*data[i+10]
			     -aux[i+ 9]*c5*data[i+ 9]
			     +aux[i+ 8]*c5*data[i+ 8]
			     +aux[i+ 7]*c4*data[i+ 7]
			     +aux[i+ 6]*c3*data[i+ 6]
			     +aux[i+ 5]*c2*data[i+ 5];
    model[i+nz-2] += aux[i+nz-6]*c1*data[i+nz-6];
    model[i+nz-3] += aux[i+nz-7]*c1*data[i+nz-7]
			        +aux[i+nz-6]*c2*data[i+nz-6];
    model[i+nz-4] += aux[i+nz-8]*c1*data[i+nz-8]
				 	+aux[i+nz-7]*c2*data[i+nz-7]
				 	+aux[i+nz-6]*c3*data[i+nz-6];
    model[i+nz-5] += aux[i+nz-9]*c1*data[i+nz-9]
				 	+aux[i+nz-8]*c2*data[i+nz-8]
			        +aux[i+nz-7]*c3*data[i+nz-7]
				 	+aux[i+nz-6]*c4*data[i+nz-6];
    model[i+nz-6] += aux[i+nz-10]*c1*data[i+nz-10]
				 	+aux[i+nz- 9]*c2*data[i+nz- 9]
			        +aux[i+nz- 8]*c3*data[i+nz- 8]
			        +aux[i+nz- 7]*c4*data[i+nz- 7]
			        +aux[i+nz- 6]*c5*data[i+nz- 6];
    model[i+nz-7] += aux[i+nz-11]*c1*data[i+nz-11]
			        +aux[i+nz-10]*c2*data[i+nz-10]
			        +aux[i+nz- 9]*c3*data[i+nz- 9]
			        +aux[i+nz- 8]*c4*data[i+nz- 8]
			        +aux[i+nz- 7]*c5*data[i+nz- 7]
			        -aux[i+nz- 6]*c5*data[i+nz- 6];
    model[i+nz-8] += aux[i+nz-12]*c1*data[i+nz-12]
			        +aux[i+nz-11]*c2*data[i+nz-11]
			        +aux[i+nz-10]*c3*data[i+nz-10]
			        +aux[i+nz- 9]*c4*data[i+nz- 9]
			        +aux[i+nz- 8]*c5*data[i+nz- 8]
			        -aux[i+nz- 7]*c5*data[i+nz- 7]
			        -aux[i+nz- 6]*c4*data[i+nz- 6];
    model[i+nz-9] += aux[i+nz-13]*c1*data[i+nz-13]
			        +aux[i+nz-12]*c2*data[i+nz-12]
			        +aux[i+nz-11]*c3*data[i+nz-11]
			        +aux[i+nz-10]*c4*data[i+nz-10]
			        +aux[i+nz- 9]*c5*data[i+nz- 9]
			        -aux[i+nz- 8]*c5*data[i+nz- 8]
			        -aux[i+nz- 7]*c4*data[i+nz- 7]
			        -aux[i+nz- 6]*c3*data[i+nz- 6];
    model[i+nz-10]+= aux[i+nz-14]*c1*data[i+nz-14]
			        +aux[i+nz-13]*c2*data[i+nz-13]
			        +aux[i+nz-12]*c3*data[i+nz-12]
			        +aux[i+nz-11]*c4*data[i+nz-11]
			        +aux[i+nz-10]*c5*data[i+nz-10]
			        -aux[i+nz- 9]*c5*data[i+nz- 9]
			        -aux[i+nz- 8]*c4*data[i+nz- 8]
			        -aux[i+nz- 7]*c3*data[i+nz- 7]
			        -aux[i+nz- 6]*c2*data[i+nz- 6];
  }
}

export void Bz_double_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform double model[], uniform double data[], uniform double aux[]){

  uniform float c1=35.0/294912.0;
  uniform float c2=-405.0/229376.0;
  uniform float c3=567.0/40960.0;
  uniform float c4=-735.0/8192.0;
  uniform float c5=19845.0/16384.0;

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
	  if (add==0) {
		for (uniform int iz=0;iz<nz;iz++){
		  model[iz+i]=0.f;
		}
	  }
      foreach(iz=9...(nz-10)) {
        model[iz+i] +=   aux[iz+i-4]*c1*data[iz+i-4]
						+aux[iz+i-3]*c2*data[iz+i-3]
						+aux[iz+i-2]*c3*data[iz+i-2]
						+aux[iz+i-1]*c4*data[iz+i-1]
						+aux[iz+i  ]*c5*data[iz+i  ]
						-aux[iz+i+1]*c5*data[iz+i+1]
						-aux[iz+i+2]*c4*data[iz+i+2]
						-aux[iz+i+3]*c3*data[iz+i+3]
						-aux[iz+i+4]*c2*data[iz+i+4]
						-aux[iz+i+5]*c1*data[iz+i+5];
	  }
    }
  }
  else {
	for (uniform int ix=bx;ix<ex;ix++) {
      uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++){
          data[iz+i]=0.f;
        }
      }
      foreach(iz=5...(nz-5)) {
        data[iz+i] += aux[iz+i]*(  c1*(-model[iz+i-5])+
								   c2*(-model[iz+i-4])+
								   c3*(-model[iz+i-3])+
								   c4*(-model[iz+i-2])+
								   c5*(-model[iz+i-1])+
								   c5*( model[iz+i  ])+
								   c4*( model[iz+i+1])+
								   c3*( model[iz+i+2])+
								   c2*( model[iz+i+3])+
								   c1*( model[iz+i+4]));
      }
    }
  }
}

export void Dt_double_c_(uniform int adj, uniform int add, uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform double model1[], uniform double model2[], uniform double data[], uniform double aux) {

  if (adj==1) {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++) {
          model1[iz+i]=0.f;
          model2[iz+i]=0.f;
        }
      }
      foreach(iz=0...nz) {
        model1[iz+i] +=-aux*data[iz+i];
        model2[iz+i] += aux*data[iz+i];
      }
    }
  }
  else {
    for (uniform int ix=bx;ix<ex;ix++) {
	  uniform int i=ix*nz;
      if (add==0) {
        for (uniform int iz=0;iz<nz;iz++) {
	      data[iz+i]=0.f;
        }
      }
      foreach(iz=0...nz) {
        data[iz+i] += aux*(model2[iz+i]-model1[iz+i]);
      }
    }
  }
}

export void Zero_array_double_c_(uniform int nx, uniform int nz, uniform int bx, uniform int ex, uniform double array[]){

  for (uniform int ix=bx;ix<ex;ix++) {
	uniform int i=ix*nz;
	for (uniform int iz=0;iz<nz;iz++) {
      array[iz+i]=0.f;
    }
  }
}
