! Program created by Gustavo Catao Alves at
! the Stanford Exploration Project
! Jan, 5th, 2015

! finite difference module
module clib_rtm_ispc

  use, intrinsic :: iso_c_binding

  implicit none

  interface
    subroutine Axsides_c(add,nx,nz,model,dataF,aux) bind(c,name='Axsides_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Ax_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Ax_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Bxsides_c(add,nx,nz,model,dataF,aux) bind(c,name='Bxsides_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Bx_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Bx_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Azsides_c(add,nx,nz,model,dataF,aux) bind(c,name='Azsides_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Az_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Az_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Bzsides_c(add,nx,nz,model,dataF,aux) bind(c,name='Bzsides_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Bz_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Bz_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Dt_c(adj,add,nx,nz,bx,ex,model1,model2,dataF,aux) bind(c,name='Dt_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),value		  :: aux
      real(c_float),dimension(*)  :: model1,model2     
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine dvxdx_c(add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='dvxdx_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),value		  :: aux      
      real(c_float),dimension(*)  :: model
      real(c_float),dimension(*)  :: dataF
    endsubroutine
    
    subroutine dvzdz_c(add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='dvzdz_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),value		  :: aux      
      real(c_float),dimension(*)  :: model
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine dvxdz_c(add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='dvxdz_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),value		  :: aux      
      real(c_float),dimension(*)  :: model
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine dvzdx_c(add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='dvzdx_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),value		  :: aux      
      real(c_float),dimension(*)  :: model
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Zero_array_c(nx,nz,bx,ex,dataF) bind(c,name='Zero_array_c_')
      import
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Axb_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Axb_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Bxb_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Bxb_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Azb_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Azb_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine

    subroutine Bzb_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Bzb_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_float),dimension(*)  :: model,aux
      real(c_float),dimension(*)  :: dataF
    endsubroutine
    
    subroutine Axsides_double_c(add,nx,nz,model,dataF,aux) bind(c,name='Axsides_double_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx
      real(c_double),dimension(*) :: model,aux
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine Ax_double_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Ax_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_double),dimension(*) :: model,aux
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine Bxsides_double_c(add,nx,nz,model,dataF,aux) bind(c,name='Bxsides_double_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx
      real(c_double),dimension(*) :: model,aux
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine Bx_double_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Bx_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_double),dimension(*) :: model,aux
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine Azsides_double_c(add,nx,nz,model,dataF,aux) bind(c,name='Azsides_double_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx
      real(c_double),dimension(*) :: model,aux
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine Az_double_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Az_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_double),dimension(*) :: model,aux
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine Bzsides_double_c(add,nx,nz,model,dataF,aux) bind(c,name='Bzsides_double_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nz,nx
      real(c_double),dimension(*) :: model,aux
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine Bz_double_c(adj,add,nx,nz,bx,ex,model,dataF,aux) bind(c,name='Bz_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_double),dimension(*) :: model,aux
      real(c_double),dimension(*) :: dataF
    endsubroutine

    subroutine Dt_double_c(adj,add,nx,nz,bx,ex,model1,model2,dataF,aux) bind(c,name='Dt_double_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_double),value		  :: aux
      real(c_double),dimension(*) :: model1,model2     
      real(c_double),dimension(*) :: dataF
    endsubroutine
    
    subroutine Zero_array_double_c(nx,nz,bx,ex,dataF) bind(c,name='Zero_array_double_c_')
      import
      integer(c_int),value        :: nz,nx,bx,ex
      real(c_double),dimension(*) :: dataF
    endsubroutine

  endinterface
end module
