! Program created by Gustavo Catao Alves at
! the Stanford Exploration Project
! Jan, 5th, 2015

! finite difference module
module clib_sinc_ispc

  use, intrinsic :: iso_c_binding

  implicit none

  interface
    function sinc_adj_serial_c(add,nf,ixrec,izrec,xrec,zrec,filter,data) bind(c,name='sinc_adj_serial_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nf,ixrec,izrec
      real(c_float),value		  :: xrec, zrec
      real(c_float),dimension(*)  :: filter,data
	endfunction
	subroutine sinc_serial_c(add,nf,ixrec,izrec,xrec,zrec,model,filter,data) bind(c,name='sinc_serial_c_')
      import
      integer(c_int),value        :: add
      integer(c_int),value        :: nf,ixrec,izrec
      real(c_float),value		  :: xrec, zrec, model
      real(c_float),dimension(*)  :: filter,data
	endsubroutine
	subroutine sinc_serial2_c(adj,add,nf,nz,nx,xrec,zrec,dx,it,dt,dtseis,ntseis,irec,nrec,aux,model,filter,data) bind(c,name='sinc_serial2_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nf,it,nz,nx,irec,nrec,ntseis
      real(c_float),value		  :: xrec, zrec,dt,dtseis,aux,dx
      real(c_float),dimension(*)  :: filter,data,model
	endsubroutine	
	subroutine sinc_serial2_fz_c(adj,add,nf,nz,nx,xrec,zrec,dx,it,dt,dtseis,ntseis,irec,nrec,aux,model,filter,data) bind(c,name='sinc_serial2_fz_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nf,it,nz,nx,irec,nrec,ntseis
      real(c_float),value		  :: xrec, zrec,dt,dtseis,aux,dx
      real(c_float),dimension(*)  :: filter,data,model
	endsubroutine	
	subroutine sinc_serial2_fx_c(adj,add,nf,nz,nx,xrec,zrec,dx,it,dt,dtseis,ntseis,irec,nrec,aux,model,filter,data) bind(c,name='sinc_serial2_fx_c_')
      import
      integer(c_int),value        :: adj,add
      integer(c_int),value        :: nf,it,nz,nx,irec,nrec,ntseis
      real(c_float),value		  :: xrec, zrec,dt,dtseis,aux,dx
      real(c_float),dimension(*)  :: filter,data,model
	endsubroutine	
  endinterface
end module
