module random_mod
  use sep
  implicit none
  logical :: randomBound,freeSurf
  integer :: thick
  real :: pctG
  
contains

  subroutine randomBoundInit()
 
    call from_param("abc",thick,60)
    call from_param("pct",pctG,.92)
    call from_param("freeSurface",freeSurf,.false.)

    thick=thick-20
    
  end subroutine
  

  
  subroutine randomizeBoundary(field,b,e)
    real,dimension(:,:) :: field
    integer,dimension(:,:),allocatable :: reg,ptnum(:,:),locs(:,:),start(:)
    real :: b,e,dmax,pct,www
    integer :: boundSize,i1,i2,ireg,ia,ib
    real :: d1,d2,val,r,psq,dbase
    logical :: done
    real,allocatable :: rnd(:),dist(:),prop(:)
    logical,allocatable :: used(:)
    logical :: grow
    integer :: dir(2,8),idist,idir,nreg,nsz
    integer :: irnd,loc(2),n1,n2,inum,iloc
    logical :: found,search
    logical :: tdir(8)
       integer :: iseed,sd(1)
    
    n1=size(field,1)
    n2=size(field,2)
    allocate(reg(n1,n2),ptnum(n1,n2))
    boundSize=size(field,1)*thick*2+size(field,2)*thick*2-thick*thick*4
    if(freeSurf) boundSize=size(field,1)*thick*2+size(field,2)*thick-thick*thick*2

    done=.false.;irnd=1;
        
    call from_param("seed",iseed,0);
    sd(1)=iseed
    call random_seed(put=sd)
    dir(:,1)=(/0,1/)
    dir(:,2)=(/0,-1/)
    dir(:,3)=(/1,1/)
    dir(:,4)=(/-1,1/)
    dir(:,5)=(/1,-1/)
    dir(:,6)=(/-1,-1/)
    dir(:,7)=(/1,0/)
    dir(:,8)=(/-1,0/)
    dmax=sqrt(1.*thick*thick)
    inum=0;

    write(0,*) "iseed",iseed
    
   
    allocate(locs(2,boundSize),used(boundSize),dist(boundSize),start((boundSize)))
    allocate(prop(boundSize))

    do i2=1,size(field,2)
      d2=0
      !LEFT SIDE
      if(i2 <= thick) then
         d2=thick-i2+1
      end if
      !RIGHT SIDE
      if(i2 > n2-thick) then
        d2=i2-(n2-thick)
      end if
      do i1=1,size(field,1)
        d1=0
        !TOP
        if(i1 <= thick .and. freeSurf == .false.) then
          d1=thick-i1+1
        end if
        !BOTTOM
        if(i1 > n1-thick) then
          d1=i1-(n1-thick)
        end if
        reg(i1,i2)=-1;
        if(d1 >.01 .or. d2>.01) then
          reg(i1,i2)=0
          !we are at a boundary
          inum=inum+1
          locs(:,inum)=(/i1,i2/)
          dist(inum)=sqrt(d1*d1+d2*d2)
          ptnum(i1,i2)=inum
        end if
      end do
    end do
    if(inum/=boundSize) call seperr("illogical boundary calc")
 
    allocate(rnd(5000))
    ireg=0;
    do while(inum>0)!{
      call random_number(rnd)
      irnd=1;
      !Find the first point 
      iloc=max(1,min(boundSize,nint((boundSize-1)*rnd(irnd)+1)))
      irnd=2
  !    write(0,*) "CHECK THIS",iloc,inum,irndls -alt
      if(used(iloc)) then !{!this piece already is part of a a boundary
        found=.false.
        idist=1
        do while(.not. found) !{
          if(.not. used(max(1,iloc-idist))) then!{
             found=.true.
             iloc=iloc-idist;
           end if!}
           if(.not. found .and. .not. used(min(boundSize,iloc+idist)))  then!{
             found=.true.
             iloc=iloc+idist
           end if!}
           idist=idist+1
        end do!}
      end if
        !we now have a point
        used(iloc)=.true.
        ireg=ireg+1
        i1=locs(1,iloc)
        i2=locs(2,iloc)
        reg(i1,i2)=ireg;
        start(ireg)=dist(iloc)
        inum=inum-1
        nsz=1;
        !Now it is time grow 
        grow=.true.
        do while(grow .and. inum>=0)
    !    write(0,*) "in grow"
           if(rnd(irnd) > pctG) then
        !   write(0,*) "cut off",rnd(irnd)
             grow=.false.
             irnd=irnd+1;
           else
             tdir=.true.
             search=.true.
             do while(any(tdir) .and. search) 
               idir=max(1,min(nint(7*rnd(irnd)+1.),8));
               irnd=irnd+1
               if(tdir(idir)) then
                 tdir(idir)=.false.
                 ia=i1+dir(1,idir)
                 ib=i2+dir(2,idir)
           !      write(0,*) "testing",ia,ib,idir
                 if(ia>0 .and. ib >0 .and. ia <=n1 .and. ib <=n2) then
                   if(reg(ia,ib)==0) then 
                     reg(ia,ib)=ireg
                     used(ptnum(ia,ib))=.true.
                     inum=inum-1
                     search=.false.
                     nsz=nsz+1
                     i1=ia; i2=ib;
                   end if
                 end if
               end if
             end do !end if testing direction
             if(.not. any(tdir) .and. searcH) then
               !we can no move any more from this location
               grow=.false.
             end if
            end if !should try to grow
          end do !grow loop
        end do ! all points assigned 
    !Now it is time to fill in cells with values
    do i1=1,ireg
      pct=start(i1)/dmax
      psq=start(i1)*start(i1)/dmax/dmax
      psq=sqrt(psq)
      dbase=((1.-pct)*b+pct*e);
      www=psq*.4; !maximum deviation
      found=.false.
      do while(.not. found)
        call random_number(r)
        r=(r-.5)*psq+dbase
        if(e>b  ) then !density case
          if(r >1. .and. r < e*3.) then
             found=.true.
             prop(i1)=r
 !write(0,*) "SETTING 1",i1,prop(i1)
          end if
        else !lamdbda,mu
          if(r > e/3. .and. r< 1.) then
            prop(i1)=r
 !write(0,*) "SETTING 2",i1,prop(i1)
            found=.true.
          end if
        end if
      end do
    end do
      do i2=1,n2
        do i1=1,n1
          if(reg(i1,i2)>0) then
            field(i1,i2)=field(i1,i2)*prop(reg(i1,i2))
          end if
        end do
      end do
    deallocate(reg,rnd,ptnum,used,locs,start,dist,prop)
    call srite("test.H",field,n1*n2*4)
  
  end subroutine

  subroutine randomVelBound(vp,vs,rho)
     real,dimension(:,:) :: vp,vs,rho
     real,allocatable :: lambda(:,:),mu(:,:)
     integer :: i1,i2
     real :: maxvp
     
     maxvp = maxval(vp)
     allocate(lambda(size(vp,1),size(vp,2)),mu(size(vp,1),size(vp,2)))
     do i2=1,size(mu,2)
       do i1=1,size(mu,1)
         mu(i1,i2)=vs(i1,i2)*vs(i1,i2)*rho(i1,i2)
         lambda(i1,i2)=vp(i1,i2)*vp(i1,i2)*rho(i1,i2)-2*mu(i1,i2)
        end do
     end do
     call randomLameBound(lambda,mu,rho)
     do i2=1,size(mu,2)
       do i1=1,size(mu,1)
         vp(i1,i2)=sqrt((lambda(i1,i2)+2*mu(i1,i2))/rho(i1,i2))
         vp(i1,i2)=min(maxvp,vp(i1,i2))
         vs(i1,i2)=sqrt(mu(i1,i2)/rho(i1,i2))
       end do
    end do
    deallocate(lambda,mu)

  end subroutine
    
  subroutine randomLameBound(lambda,mu,rho)
    real,dimension(:,:) :: lambda,mu,rho
   
    call randomizeBoundary(lambda,1.,.18)
    call randomizeBoundary(mu,1.,.18)
    call randomizeBoundary(rho,1.,6.0)
   
  end subroutine
  



end module
